''    ____                   ____  ____  ______   __                           __             
''   / __ \_________  ____  / __ )/ __ \/ ____/  / /   ____ ___  ______  _____/ /_  ___  _____
''  / /_/ / ___/ __ \/ __ \/ __  / / / / __/    / /   / __ `/ / / / __ \/ ___/ __ \/ _ \/ ___/
'' / ____/ /  / /_/ / /_/ / /_/ / /_/ / /___   / /___/ /_/ / /_/ / / / / /__/ / / /  __/ /    
''/_/   /_/   \____/ .___/_____/\____/_____/  /_____/\__,_/\__,_/_/ /_/\___/_/ /_/\___/_/     
''                /_/                                                                           
''                                  
'' PROPBOE PROGRAM LAUNCHER & SID PLAYER 
'' BY JEFF LEDGER AKA OLDBITCOLLECTOR
''
'' Wire two pushbuttons to the PropBOE to control this menu.
'' SELECT_BUTTON will move the selection arrow down the list.
'' LAUNCH_BUTTON will launch the .bin program from the SD card.
''
'' VGA is expected at P8-P15
'' Sound is expected on P26-P27
'' Switches can be adjusted below.
''
CON
 
   _clkmode  = xtal1 + pll16x
   _xinfreq  = 5_000_000
    playRate = 50'Hz       

  spiDO     = 22
  spiClk    = 23
  spiDI     = 24
  spiCS     = 25

  SELECT_BUTTON = 0
  LAUNCH_BUTTON = 1

OBJ
     text  : "50xH_ui"   

    strings : "strings"
       fsrw : "fsrwFemto"      
        SID : "SIDCog" 
      
 
VAR
  long ioControl[2]

  long  numfiles
  long  offset
  long  selected
  long  redraw
  byte  fnames[256*16]
  byte  fname[16]

  long numsids
  long sidoffset
  long sidselected
  byte sidnames[256*16]
  byte sidname[16]
  
  byte filebuffer[512]
  byte strbuff[5]
  byte tbuf[20]

  byte  sidbuffer[25]

PUB main |  character_x, character_y, character_chr, character_color, pos, scroller,delay,row,col,xx

  text.init

  text.str(string(text#ESC, "s"))                         ' page mode
  SID.start  
  fsrw.start(@ioControl)
  if \fsrw.mount(spiDO,spiClk,spiDI,spiCS) < 0
      text.locate (0,10)            
      text.str(string("SD card not found.",13))
       abort

  text.backcolor(0)
  text.cls
  text.locate(7,1)
  text.textcolor(111)
  text.str(string("       PROPBOE SOFTWARE MENU"))
  text.locate(7,2)
  text.str(string("       ---------------------"))
  text.textcolor(12)

  getlist
  getsids
  displaylist
  
  fsrw.popen(string("song.dmp"),"r")   ' Open the tune

  text.locate(4,selected+4)
  text.textcolor(111)
  text.str(string("#>"))
  row:=4
  col:=0  
  repeat

    text.redefine(35,0,0,xx,xx,xx,0,0,0)  
    xx:=xx+20
    if xx > 200
       xx:=1

       
    '' KICK SOME SID TUNES FROM THE SD CARD.
    waitcnt(cnt+(clkfreq/playRate))     ' Wait one VBL
    if( fsrw.pread(@sidbuffer,25)) > 0       ' Read 25 bytes from SD card
     SID.updateRegisters(@sidbuffer)        ' Write 25 byte to SIDcogs 25 registers


    'MIGS.readMIGS
    
    if ina[SELECT_BUTTON] == 1 and selected < numfiles -1
      text.locate(row,selected+4-col)
       text.str(string("  "))
       selected++
       if selected == 19
          row:=row+15
          col:=col+selected
       text.locate(row,selected+4-col)
       text.str(string("#>"))

         
    waitcnt(cnt+(clkfreq/playRate))     ' Wait one VBL
    if( fsrw.pread(@sidbuffer,25)) > 0       ' Read 25 bytes from SD card

     SID.updateRegisters(@sidbuffer)        ' Write 25 byte to SIDcogs 25 registers

       
    waitcnt(cnt+(clkfreq/playRate))     ' Wait one VBL
    if( fsrw.pread(@sidbuffer,25)) > 0       ' Read 25 bytes from SD card
     SID.updateRegisters(@sidbuffer)        ' Write 25 byte to SIDcogs 25 registers

    if ina[LAUNCH_BUTTON] == 1
      fsrw.popen(@fnames[((selected+offset)*16)],"r")          
      fsrw.bootSDCard

    waitcnt(cnt+(clkfreq/playRate))     ' Wait one VBL
    if( fsrw.pread(@sidbuffer,25)) > 0       ' Read 25 bytes from SD card
     SID.updateRegisters(@sidbuffer)        ' Write 25 byte to SIDcogs 25 registers

    waitcnt(cnt+(clkfreq/playRate))     ' Wait one VBL
    if( fsrw.pread(@sidbuffer,25)) > 0       ' Read 25 bytes from SD card
     SID.updateRegisters(@sidbuffer)        ' Write 25 byte to SIDcogs 25 registers
    else
      fsrw.pclose
      sidselected++
      if sidselected >  numsids
         sidselected:=1
      fsrw.popen(@sidnames[((sidselected+sidoffset)*16)],"r") 

    delay++

    
    '' GREETING SCROLLER AT THE BOTTOM OF THE MENU
    if delay == 2
       pos++
       text.locate (15,32)
       text.str(scroller)
       scroller:=strings.SubStr (string("...........................................USE BUTTON CONNECTED TO P0 TO SELECT FILE AND BUTTON CONNECTED TO P1 TO LAUNCH THE PROGRAM....ENJOY....JEFF LEDGER.............................."), pos, 20)
       if pos > 150
          pos := 0
       delay:=0

PUB displaylist | name,counter,ud,lr
  ud:=4
  lr:=6
  counter:=0

  repeat numfiles

     name:=strings.substr(@fnames,counter,16)
     text.locate(lr,ud)   
     text.str(name)
     counter:=counter+16
     ud++
     if ud == 23
        lr:=lr+15
        ud:=4
     
PUB getlist | t,x,y
  numfiles:=0
  fsrw.opendir
  repeat while fsrw.nextfile(@fname) == 0
    y:=0
    repeat x from 0 to 8
      if fname[x]=="."
        if fname[x+1]=="B" and fname[x+2]=="I" and fname[x+3]=="N"
          y:=1
          x:=8
    if y==1
      longmove(@fnames[numfiles*16],@fname,16/4)
      numfiles++
    
  redraw:=1
  offset:=0
  selected:=0   
    
 
PUB getsids | t,x,y
  numsids:=0
  fsrw.opendir
  repeat while fsrw.nextfile(@sidname) == 0
    y:=0
    repeat x from 0 to 8
      if sidname[x]=="."
        if sidname[x+1]=="D" and sidname[x+2]=="M" and sidname[x+3]=="P"
          y:=1
          x:=8
    if y==1
      longmove(@sidnames[numsids*16],@sidname,16/4)
      numsids++
    
  sidoffset:=0
  sidselected:=0 

PRI textComp(str1,str2,len)
   repeat len
      if byte[str1++] <> byte[str2++]
         return false
   return true

PRI StrRight(str,len) | i,l,z,j

  l:=strSize(str)
  z:=0
  repeat i from l-len to l
    strbuff[z] := byte[@tbuf][i]
    z++
  return @strbuff
     